from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, Boolean, String

Fasterq_Dump_2_10_8_V0_1_0 = CommandToolBuilder(tool="fasterq_dump.2.10.8", base_command=["fasterq-dump.2.10.8"], inputs=[ToolInput(tag="in_outfile", input_type=File(optional=True), prefix="--outfile", doc=InputDocumentation(doc="full path of outputfile (overrides usage\nof current directory and given accession)")), ToolInput(tag="in_outdir", input_type=File(optional=True), prefix="--outdir", doc=InputDocumentation(doc="path for outputfile (overrides usage of\ncurrent directory, but uses given\naccession)")), ToolInput(tag="in_bufsize", input_type=Int(optional=True), prefix="--bufsize", doc=InputDocumentation(doc="size of file-buffer (dflt=1MB, takes\nnumber or number and unit)")), ToolInput(tag="in_cur_cache", input_type=Int(optional=True), prefix="--curcache", doc=InputDocumentation(doc="size of cursor-cache (dflt=10MB, takes\nnumber or number and unit)")), ToolInput(tag="in_mem", input_type=Int(optional=True), prefix="--mem", doc=InputDocumentation(doc="memory limit for sorting (dflt=100MB,\ntakes number or number and unit)")), ToolInput(tag="in_temp", input_type=File(optional=True), prefix="--temp", doc=InputDocumentation(doc="path to directory for temp. files\n(dflt=current dir.)")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="how many threads to use (dflt=6)")), ToolInput(tag="in_progress", input_type=Boolean(optional=True), prefix="--progress", doc=InputDocumentation(doc="show progress (not possible if stdout used)")), ToolInput(tag="in_details", input_type=Boolean(optional=True), prefix="--details", doc=InputDocumentation(doc="print details of all options selected")), ToolInput(tag="in_split_spot", input_type=Boolean(optional=True), prefix="--split-spot", doc=InputDocumentation(doc="split spots into reads")), ToolInput(tag="in_split_files", input_type=Boolean(optional=True), prefix="--split-files", doc=InputDocumentation(doc="write reads into different files")), ToolInput(tag="in_split_three", input_type=Boolean(optional=True), prefix="--split-3", doc=InputDocumentation(doc="writes single reads into special file")), ToolInput(tag="in_concatenate_reads", input_type=Boolean(optional=True), prefix="--concatenate-reads", doc=InputDocumentation(doc="writes whole spots into one file")), ToolInput(tag="in_stdout", input_type=Boolean(optional=True), prefix="--stdout", doc=InputDocumentation(doc="print output to stdout")), ToolInput(tag="in_force", input_type=Boolean(optional=True), prefix="--force", doc=InputDocumentation(doc="force overwrite of existing file(s)")), ToolInput(tag="in_rowid_as_name", input_type=Boolean(optional=True), prefix="--rowid-as-name", doc=InputDocumentation(doc="use rowid as name (avoids using the name\ncolumn)")), ToolInput(tag="in_skip_technical", input_type=Boolean(optional=True), prefix="--skip-technical", doc=InputDocumentation(doc="skip technical reads")), ToolInput(tag="in_include_technical", input_type=Boolean(optional=True), prefix="--include-technical", doc=InputDocumentation(doc="explicitly include technical reads")), ToolInput(tag="in_print_read_nr", input_type=Boolean(optional=True), prefix="--print-read-nr", doc=InputDocumentation(doc="include read-number in defline")), ToolInput(tag="in_min_read_len", input_type=Int(optional=True), prefix="--min-read-len", doc=InputDocumentation(doc="filter by sequence-lenght")), ToolInput(tag="in_table", input_type=String(optional=True), prefix="--table", doc=InputDocumentation(doc="which seq-table to use in case of pacbio")), ToolInput(tag="in_strict", input_type=Boolean(optional=True), prefix="--strict", doc=InputDocumentation(doc="terminate on invalid read")), ToolInput(tag="in_filter_output_given", input_type=String(optional=True), prefix="--bases", doc=InputDocumentation(doc="filter output by matching against given")), ToolInput(tag="in_ngc", input_type=File(optional=True), prefix="--ngc", doc=InputDocumentation(doc="<path> to ngc file")), ToolInput(tag="in_perm", input_type=File(optional=True), prefix="--perm", doc=InputDocumentation(doc="<path> to permission file")), ToolInput(tag="in_location", input_type=String(optional=True), prefix="--location", doc=InputDocumentation(doc="location in cloud")), ToolInput(tag="in_cart", input_type=File(optional=True), prefix="--cart", doc=InputDocumentation(doc="<path> to cart file")), ToolInput(tag="in_disable_multithreading", input_type=Boolean(optional=True), prefix="--disable-multithreading", doc=InputDocumentation(doc="disable multithreading")), ToolInput(tag="in_log_level", input_type=Int(optional=True), prefix="--log-level", doc=InputDocumentation(doc="Logging level as number or enum string.\nOne of\n(fatal|sys|int|err|warn|info|debug) or\n(0-6) Current/default is warn")), ToolInput(tag="in_option_file", input_type=File(optional=True), prefix="--option-file", doc=InputDocumentation(doc="Read more options and parameters from the")), ToolInput(tag="in_append_outputfile_instead", input_type=String(), position=0, doc=InputDocumentation(doc="-A|--append                      append to output-file, instead of")), ToolInput(tag="in_file_dot", input_type=File(), position=0, doc=InputDocumentation(doc="-h|--help                        print this message"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Fasterq_Dump_2_10_8_V0_1_0().translate("wdl", allow_empty_container=True)

